#pragma once

class CScene;

class CApplication
{

#pragma region Singleton
public:
	static CApplication * GetInstance(void) {
		static CApplication * instance = new CApplication();
		return instance;
	}
#pragma endregion

public:
	void InitWindow(void);
	void InitGL(void);
	void ProcessEvents(void);
	void Cleanup(void);
	double GetTime(void);
	void Redraw(void);
	void Update(void);
	void GameLoop(void);
	void Start(void);

	static void HandleGLFWError(int error, const char* description);

	CScene * CurrentScene;

	GLFWwindow * window;

private:
	CApplication(void);
	~CApplication(void);

};
